
/////////////////////////////////////////////////////////////
//
// Source file for BigBox
//
//    This file is generated by RapidApp 1.2
//
//    This class is derived from BigBoxUI which 
//    implements the user interface created in 
//    RapidApp. This class contains virtual
//    functions that are called from the user interface.
//
//    When you modify this source, limit your changes to 
//    modifying the sections between the
//    "//---- Start/End editable code block" markers
//
//    This will allow RapidApp to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
/////////////////////////////////////////////////////////////

#include "BigBox.h"
#include <Xm/BulletinB.h> 
#include <Xm/Scale.h> 
#include <Vk/VkResource.h>


// Externally defined classes referenced by this class:

#include <Inventor/Xt/viewers/SoXtPlaneViewer.h>
#include <Inventor/So.h> // Includes ALL Inventor headers.
                         // Replace for efficiency and faster compilaton


extern void VkUnimplemented ( Widget, const char * );

///////////////////////////////////////////////////////////////////////////////
// The following non-container elements are created by BigBoxUI and are
// available as protected data members inherited by this class
//
//  XmScale		    _scale
//
// The following components are created by BigBoxUI and are
// available as protected data members inherited by this class
//
//  SoXtPlaneViewer		   *_viewerFinal
//  SoXtPlaneViewer		   *_viewerMorphed
//  SoXtPlaneViewer		   *_viewerInitial
//
///////////////////////////////////////////////////////////////////////////////


//---- Start editable code block: headers and declarations

#include "InventorStuff.h"
#include "morph.h"
#include <Vk/VkErrorDialog.h>

//---- End editable code block: headers and declarations



//---- BigBox Constructor

BigBox::BigBox(const char *name, Widget parent) : 
                   BigBoxUI(name, parent) 
{ 
    // This constructor calls BigBoxUI(parent, name)
    // which calls BigBoxUI::create() to create
    // the widgets for this component. Any code added here
    // is called after the component's interface has been built

    //---- Start editable code block: BigBox constructor

    initImageGraph(_viewerInitial,0);
    initImageGraph(_viewerMorphed,1);
    initImageGraph(_viewerFinal,2);

    //---- End editable code block: BigBox constructor



}    // End Constructor



BigBox::BigBox(const char *name) : 
                   BigBoxUI(name) 
 { 
    // This constructor calls BigBoxUI(name)
    // which does not create any widgets. Usually, this
    // constructor is not used

    //---- Start editable code block: BigBox constructor 2


    //---- End editable code block: BigBox constructor 2



}    // End Constructor



BigBox::~BigBox()
{
    // The base class destructors are responsible for
    // destroying all widgets and objects used in this component.
    // Only additional items created directly in this class
    // need to be freed here.

    //---- Start editable code block: BigBox destructor


    //---- End editable code block: BigBox destructor



}    // End Destructor


const char * BigBox::className() // classname
{
    return ("BigBox");
} // End className()


void BigBox::performMorph ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BigBox performMorph

    XmScaleCallbackStruct *cbs = (XmScaleCallbackStruct*) callData;

    //--- Comment out the following line when BigBox::performMorph is implemented:

    //::VkUnimplemented ( w, "BigBox::performMorph" );

     char *msg = morph::morphAtParameter((float)(cbs->value)/1000);
     if(msg) theErrorDialog->post(msg); 


    //---- End editable code block: BigBox performMorph

}    // End BigBox::performMorph()





///////////////////////////////////////////////////////////////////
// static creation function, for importing class into rapidapp
// or dynamically loading, using VkComponent::loadComponent
///////////////////////////////////////////////////////////////////


VkComponent *BigBox::CreateBigBox( const char *name, Widget parent ) 
{  
    VkComponent *obj =  new BigBox ( name, parent );
    return ( obj );
} // End CreateBigBox


///////////////////////////////////////////////////////////////////
// Function for accessing a description of the dynamic interface
// to this class.
///////////////////////////////////////////////////////////////////


// WARNING: This structure is different than that used with 1.1 RapidApp.
// See the RapidApp release notes for details

struct InterfaceMap {
  char  *resourceName;
  char  *methodName;
  char  *argType;
  char  *definingClass; // Optional, if not this class
  void (VkCallbackObject::*method)(...); // Reserved, do not set
};


void *BigBox::RegisterBigBoxInterface()
{ 
    // This structure registers information about this class
    // that allows RapidApp to create and manipulate an instance.
    // Each entry provides a resource name that will appear in the
    // resource manager palette when an instance of this class is
    // selected, the name of the member function as a string,
    // the type of the single argument to this function, and an.
    // optional argument indicating the class that defines this function.
    // All member functions must have the form
    //  
    //     void memberFunction ( Type );
    //
    // where "Type" is one of:
    //    const char *    (Use XmRString)
    //    Boolean         (Use XmRBoolean)
    //    int             (Use XmRInt)
    //    float           (Use XmRFloat)
    //    No argument     (Use VkRNoArg or "NoArg"
    //    A filename      (Use VkRFilename or "Filename")
    //    An enumeration  (Use "Enumeration:ClassName:Type: VALUE1, VALUE2, VALUE3")
    //    A callback      (Use XmRCallback)


    static InterfaceMap map[] = {
    //---- Start editable code block: BigBoxUI resource table

      // { "resourceName", "setAttribute", XmRString},
    //---- End editable code block: BigBoxUI resource table
      { NULL }, // MUST be NULL terminated
    };

    return map;
} // End RegisterBigBoxInterface()






//---- End of generated code

//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code


