#ifndef __INVENTOR_STUFF_H__
#define __INVENTOR_STUFF_H__


// Image data are stored in the following way:
// red component of pixel in lower left corner, followed by green component,
// followed by blue component of same pixel, followed by red component
// of the next pixel to the right, ... and so on.
// in general, pixel (i,j) is stored at locations data[(i+j*width)*3], +1, +2
//    where i grows to the right and j grows up; 0<=i<width, 0<=j<height


class SoXtViewer;


void initImageGraph(SoXtViewer *viewer, int window);

const unsigned char* readImage_RGB(int window, // 0 = initial, 2 = final
			     const char *filename,
			     int &width, int &height);

void displayImage(int window, // 0 = initial, 1 = morph, 2 = final
		  int width, int height,
		  unsigned char *imgData);

void hideLines(int window);
void showLines(int window);



typedef void t_mapfn(float x, float y, int fromWin, int toWin, float& xm, float &ym);

unsigned char* inventorWarp(int gridsize,  //size of uniform grid on the initial img 
			    int fromWin, // index of the initial image window
			    t_mapfn mapfn, // DIRECT mapping function 
			    int width, int height,
			    int rendererNo // 0 or 1
			    );

void toggleLastWarpGrid(int win); // will display the last grid used for warping

#endif
