
//////////////////////////////////////////////////////////////
//
// Header file for mainWindow
//
//    This class is a subclass of VkWindow
//
// Normally, very little in this file should need to be changed.
// Create/add/modify menus using RapidApp.
//
// Restrict changes to those sections between
// the "//--- Start/End editable code block" markers
// Doing so will allow you to make changes using RapidApp
// without losing any changes you may have made manually
//
//////////////////////////////////////////////////////////////
#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#include <Vk/VkWindow.h>


class VkMenuItem;
class VkMenuToggle;
class VkMenuConfirmFirstAction;
class VkSubMenu;
class VkRadioSubMenu;

//---- Start editable code block: headers and declarations


//---- End editable code block: headers and declarations


//---- mainWindow class declaration

class mainWindow: public VkWindow {

  public:

    mainWindow( const char * name, 
                ArgList args = NULL,
                Cardinal argCount = 0 );
    ~mainWindow();
    const char *className();
    virtual Boolean okToQuit();

    //---- Start editable code block: mainWindow public


    //---- End editable code block: mainWindow public


  protected:

    void afterRealizeHook();



    // Classes created by this class

    class BigBox *_bigBox;


    // Widgets created by this class


    // Menu items created by this class
    VkSubMenu  *_filePane;
    VkMenuItem *_new1;
    VkMenuItem *_newButton;
    VkMenuItem *_openButton;
    VkMenuItem *_saveButton;
    VkMenuItem *_separator1;
    VkMenuItem *_initialImg;
    VkMenuItem *_finalImg;
    VkMenuItem *_saveFrame;
    VkMenuItem *_saveMovie;
    VkMenuItem *_separator2;
    VkMenuItem *_exitButton;
    VkSubMenu  *_view;
    VkSubMenu  *_show;
    VkMenuToggle *_warpedInitial;
    VkMenuToggle *_morphed;
    VkMenuToggle *_warpedFinal;
    VkMenuToggle *_interpLines;

    // Member functions called from callbacks

    virtual void doFinalImg ( Widget, XtPointer );
    virtual void doInitialImg ( Widget, XtPointer );
    virtual void doNew ( Widget, XtPointer );
    virtual void doSaveFrame ( Widget, XtPointer );
    virtual void doSaveMovie ( Widget, XtPointer );
    virtual void openFile ( Widget, XtPointer );
    virtual void quit ( Widget, XtPointer );
    virtual void save ( Widget, XtPointer );
    virtual void saveas ( Widget, XtPointer );
    virtual void setInterpLines ( Widget, XtPointer );
    virtual void setMorphed ( Widget, XtPointer );
    virtual void setWarpedFinal ( Widget, XtPointer );
    virtual void setWarpedInitial ( Widget, XtPointer );


    //---- Start editable code block: mainWindow protected


    //---- End editable code block: mainWindow protected


  private:


    // Callbacks to interface with Motif

    static void doFinalImgCallback ( Widget, XtPointer, XtPointer );
    static void doInitialImgCallback ( Widget, XtPointer, XtPointer );
    static void doNewCallback ( Widget, XtPointer, XtPointer );
    static void doSaveFrameCallback ( Widget, XtPointer, XtPointer );
    static void doSaveMovieCallback ( Widget, XtPointer, XtPointer );
    static void openFileCallback ( Widget, XtPointer, XtPointer );
    static void quitCallback ( Widget, XtPointer, XtPointer );
    static void saveCallback ( Widget, XtPointer, XtPointer );
    static void saveasCallback ( Widget, XtPointer, XtPointer );
    static void setInterpLinesCallback ( Widget, XtPointer, XtPointer );
    static void setMorphedCallback ( Widget, XtPointer, XtPointer );
    static void setWarpedFinalCallback ( Widget, XtPointer, XtPointer );
    static void setWarpedInitialCallback ( Widget, XtPointer, XtPointer );

    static String  _defaultmainWindowResources[];


    //---- Start editable code block: mainWindow private


    //---- End editable code block: mainWindow private


};
//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code

#endif
