#include "morph.h"
#include "InventorStuff.h"
#include <string.h>
#include <fstream.h>




char morph::initialImgName[100] = "", morph::finalImgName[100] = "";
char morph::configFile[100] = "";
const unsigned char* morph::initialImg, *morph::finalImg;
unsigned char* morph::morphedImg=0;
int morph::width=0, morph::height=0;
morph::t_view morph::view = morph::morphed;

void morph::init(){;}
void morph::showInterpLines(int val){;}
void morph::nnew(){;}
char* morph::open(const char * fname){return 0;}
char* morph::save(const char *file){return 0;}
char* morph::saveFrame(const char *file){return 0;}
char* morph::saveMovie(const char *file){return 0;}
void morph::directMap(float x, float y, int fromWin, int toWin,
		      float& xm, float &ym){;}

void delKey(int win,int winx, int winy,float x, float y,int line,int pt){;}
void mouseDown(int button,int win,
	       int winx, int winy, // pixels
	       float x, float y, // image coordinates 0..1
	       int line,int pt){;}
void mouseUp(int button,int win, 
	     int winx, int winy,  // pixels
	     float x, float y, // image coordinates 0..1
	     int line,int pt){;}
void mouseMove(int win,
	       int winx, int winy,  // pixels
	       float x, float y,
	       int line,int pt){;}

///////////////////////////////////////////////////////////////////////////

char* morph::morphAtParameter(float t){
    if(!initialImg) return("No Initial Image");
    if(!finalImg) return("No Final Image");

    if( morphedImg ) delete morphedImg;
    morphedImg = new unsigned char[3*width*height];

    unsigned char *m = morphedImg;
    const unsigned char* iImg = initialImg, * fImg = finalImg;
    int size = 3*width*height;
    for(int i=0; i<size; i++)
	*(m++) = (1-t) * (*(iImg++)) + t * (*(fImg++));

    displayImage(1, width, height, morphedImg);

    return 0;
}

///////////////////////////////////////////////////////////////////////////

char* morph::loadInitialImg(const char *file){
    if( strstr(file,".rgb") ){
	strcpy(initialImgName, file);
	int w,h;
	initialImg = readImage_RGB( 0 , // initial
				    file,
				    w, 
				    h);
	if( (width||height) ){
	  if (w!=width || h!=height){
	    initialImg = 0;
	    initialImgName[0] = 0;
	    readImage_RGB( 0 , "", w,h);
	    return "Different image dimensions";
	  } 
	} else { width=w; height=h; }
    }
    return 0;
}

///////////////////////////////////////////////////////////////////////////

char* morph::loadFinalImg(const char *file){
    if( strstr(file,".rgb") ){
	strcpy(finalImgName, file);
	int w,h;
	finalImg = readImage_RGB( 2 , // 2 = final
				  file,
				  w, 
				  h);
	if( (width||height) ){
	  if (w!=width || h!=height){
	    finalImg = 0;
	    finalImgName[0] = 0;
	    readImage_RGB( 2 , "", w,h);
	    return "Different image dimensions";
	  }
	} else { width=w; height=h; }
    }
    return 0;
}


